package org.wffm.gassan.model.scenario;

/*
 * GElementList.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
import java.io.Serializable;

import org.w3c.dom.Node;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
  * \vfXg
  * @version 1.1.2, 2000/11/18
  * @author Yosuke Sato
  */
public class GElementList extends GElement implements Serializable{
	//
	//  W
	//
	//=========================================================================
	private Node _childNode = null;	//m[h̃XgwJ[\i|C^j̏Ԃ\

	//
	//  [Jϐ
	//
	//=========================================================================
	private int state = 0;
/**
  * RXgN^
  * @param	aGElement	\vf
  */
public GElementList(GElement aGElement){
	super(aGElement.getNode(),aGElement.getBaseURL(),aGElement.getCurrentDocument());
}
/**
  * J[\ŏ̗vfֈړ
  */
public void first(){
	_childNode = getNode().getFirstChild();

	nextNode();
}
/**
  * ݂̃J[\ʒu̗vf
  * @return	\vf
  */
public GElement item(){
	GElement ret = null;

	if( _childNode != null ){
		ret = new GElement( _childNode , getBaseURL(), getCurrentDocument()) ;
	}
	
	return ret;
}
/**
  * J[\̗vfֈړ
  */
public void next(){
	if(_childNode != null){
		_childNode = _childNode.getNextSibling();
	
		nextNode();
	}
	else{
		System.out.println("childNode is NULL.");
	}
}
private void nextNode(){
	//Node.ELEMENT_NODËʒu܂ŃJ[\i߂
	for(;_childNode !=null;_childNode = _childNode.getNextSibling()){
		if(_childNode.getNodeType() == Node.ELEMENT_NODE){
			break;
		}
	}
}
/**
  * ݂̃J[\ʒuŌ̈ʒu܂ł̗vf̒ŗvf name vf̈ʒu܂ŃJ[\ړ
  * @param	name	vf̖O
  */
public void search(String name){
	GElement element = item();
	while( element != null){
		if(element.getName().equals( name )){
				break;
		}
		next();
		element = item();
	}
}
}
