/* Public Domain Sources */

package org.wffm.gassan.view.composer;

import java.awt.image.BufferedImage;
import java.awt.Image;
import java.awt.Toolkit;

import java.awt.image.ImageProducer;
import java.awt.image.FilteredImageSource;

import org.wffm.gassan.view.image.ImageCreaterException;import org.wffm.gassan.view.image.ImageCreater;import java.util.List;/**
  * }XNNX
  * @version 1.0.0, 2000/12/01
  * @author D.Miki
  * @author Yosuke Sato
  */
public class MaskTransparentFilter extends Composer {
public static Image filtering(Image i, BufferedImage mask) {
	return Toolkit.getDefaultToolkit().createImage(
		new FilteredImageSource(i.getSource(),new MaskTransparentFilter(mask))
	);
}            
	//
	//  [Jϐ
	//
	//=========================================================================
	private BufferedImage mask;
/**
 * RXgN^
 * @param	mask	}XNC[W
 */
public MaskTransparentFilter(BufferedImage mask) {
	super();
	canFilterIndexColorModel = true;
	this.mask = mask;
}

public int filterRGB(int x, int y, int rgb) {
	try{
		return (rgb & ((0xff - mask.getRGB(x, y) % 0x0100) * 0x01000000 + 0x00ffffff));
	}catch(Exception e){
		return rgb;
	}
}            
/**
 * RXgN^
 */
public MaskTransparentFilter() {
	super();
	canFilterIndexColorModel = true;
}/**
  * C[W擾
  * @return	C[W
  */
public Image getImage() throws ImageCreaterException{
	Image ret = null;

	try{
		ImageCreater creater;
		 
		creater = (ImageCreater)getSource().get(0);
		Image sourceImage = creater.getImage();

		creater = (ImageCreater)getSource().get(1);
		mask = createBufferedImage(creater.getImage());
		
		ret = Toolkit.getDefaultToolkit().createImage( new FilteredImageSource(sourceImage.getSource(), this));
	}catch(Exception e){
		throw new ImageCreaterException();
	}
	return ret;
}}