package org.wffm.gassan.view.effect;

/*
 * Kuropata_Width.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Color;
import java.awt.Graphics;

/**
  * C[WɃp^p^GtFNgNX(xʂ)
  * @version 1.1.0, 2000/01/06
  * @author Yosuke Sato
  */
public class Kuropata_Width extends ExchangeEffect {
	//
	//  [Jϐ
	//
	//=========================================================================
	private static int patapata = 16;	//p^p^̉
	private static int timer = 25;
/**
  * RXgN^
  */
public Kuropata_Width() {
}
/**
  * ʏ
  */
public void init(){
}
private void patapataDraw(Graphics g,int j) {
	for(int i = 0;i < (int)getImageSize().getWidth()/patapata ; i++){
		g.fillRect((i*patapata),0,j,(int)getImageSize().getHeight());
	}
}
private void patapataDraw_Clear(Graphics g,int j) {
	for(int i = 0;i < (int)getImageSize().getWidth()/patapata ; i++){
		g.fillRect((patapata + (i*patapata)) - j,0,j,(int)getImageSize().getHeight());
	}
}
/**
  * ʏJn
  */
public void run(){
	//O:getImageSize(),getComponent(),getBeforeImage(),getAfterImage()nullłȂƁD
	if(getImageSize() != null && getComponent() != null && getBeforeImage() != null && getAfterImage() != null){
		Image buff = getComponent().createImage((int)getImageSize().getWidth(),(int)getImageSize().getHeight());
		Graphics g = getComponent().getGraphics();
		Graphics gc = buff.getGraphics();
		gc.setColor(Color.black);
		//O
		gc.drawImage(getBeforeImage(),0,0,getComponent());
		for(int i = 0;i <= patapata;i++){
			patapataDraw(gc,i);
			timer(timer);
			g.drawImage(buff,0,0,getComponent());
		}
		timer(timer*7);
		//㔼
		for(int i = patapata;i > 0;i--){
			gc.drawImage(getAfterImage(),0,0,getComponent());
			patapataDraw_Clear(gc,i);
			timer(timer);
			g.drawImage(buff,0,0,getComponent());
		}
	}
	else{
		System.err.println("can not run : Kuropata_Width");
	}
}
}
