package org.wffm.gassan.view.plugin.movie;

/*
 * FlashMoviePanel.java - Short Description
 * Copyright (C) 2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.*;
import java.awt.*;
import javax.swing.*;

import com.macromedia.flash.*;

import org.wffm.gassan.view.plugin.GPlugin;

/**
  * FlashĐppl
  * @version 1.0.0, 2001/01/22
  * @author Yosuke Sato
  */
public class FlashMoviePanel extends JPanel implements Runnable{
	//
	//  ֘A
	//
	//=========================================================================
	private GPlugin _plugin = null;
	
	//
	//  [Jϐ
	//
	//=========================================================================
	private FlashApi flashPlayer;
	private volatile Thread kick = null;

	private final static int interval = 500;
/**
 * RXgN^
 */
public FlashMoviePanel() {
	super();
}
/**
  * RvOC擾
  * @return	RvOC
  */
public GPlugin getGPlugin(){
	return _plugin;
}
/**
  * 
  * @param url	Flash[r[URL
  */
public void init(URL url) throws Exception{
	try{
		flashPlayer = new FlashApi(new Flash()); 
		flashPlayer.SetComponent(this);
		flashPlayer.LoadScript(url.openStream());

		//Flash[r[̉掿HIGHɐݒ肷
		flashPlayer.SetQuality(FlashApi.QUALITY_HIGH,false);

		//Flash[r[̏
		flashPlayer.Startup();
		
	}catch(Exception e){
		flashPlayer = null;
		throw new Exception();
	}
}
public void paintComponent(Graphics g) {
	super.paintComponent(g);
	if(flashPlayer != null){
		flashPlayer.Paint(g);
	}
}
public void run(){
	Thread thisThread = Thread.currentThread();
	while (kick == thisThread) {
		try {
			thisThread.sleep(interval);
		} catch (InterruptedException e){
		}
		if( flashPlayer != null){
			if( !flashPlayer.IsPlaying() ){
				//I
				if(kick != thisThread){
					return;
				}
				else{
					stop();
					if(getGPlugin() != null && getGPlugin().getStage() != null){
						getGPlugin().getStage().reaction();
					}
				}
			}
		}
	}
}
/**
  * RvOCݒ
  * @param	_plugin	RvOC
  */
public void setGPlugin(GPlugin _plugin){
	this._plugin = _plugin;
}
/**
  * X^[g
  */
public void start(){
	if(flashPlayer != null){
		flashPlayer.Play();
	}
	kick = new Thread(this);
	kick.start();
}
/**
  * Xgbv
  */
public void stop(){
	if(flashPlayer!=null){
		flashPlayer.StopPlay();
		flashPlayer.StopSound();
	}
	if(kick != null){
		kick = null;
	}
}
}
