package org.wffm.gassan.sample;

/*
 * Patapata_Width.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.mars.dti.ne.jp/~y-sato/wffm/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import java.awt.Rectangle;

import org.wffm.gassan.view.effect.ExchangeEffect;

/**
  * C[WɃp^p^TvŃGtFNgNX
  * @version 1.1.1, 2001/01/06
  * @author Yosuke Sato
  */
public class SampleEffect extends ExchangeEffect {
	private static int patapata = 16;	//p^p^̉
	private static int timer = 25;
	/**
	  * RXgN^
	  */
	public SampleEffect() {
	}
/**
  * ʏ
  */
public void init() {
}
private void patapataDraw(Graphics g,int j) {
	for(int i = 0;i < (int)getImageSize().getWidth()/patapata ; i++){
		g.setClip(new Rectangle((i*patapata),0,j,(int)getImageSize().getHeight()));
		g.drawImage(getAfterImage(),0,0,getComponent());
	}
}
/**
  * ʏJn
  */
public void run(){
	//O:getImageSize(),getComponent(),getBeforeImage(),getAfterImage()nullłȂƁD
	if(getImageSize() != null && getComponent() != null && getBeforeImage() != null && getAfterImage() != null){
		Graphics g = getComponent().getGraphics();
		g.drawImage(getBeforeImage(),0,0,getComponent());
		for(int i = 0;i <= patapata;i++){
			patapataDraw(g,i);
			timer(timer);
		}
	}
	else{
		System.err.println("can not run : SampleEffect");
	}
}
}
