package org.wffm.gassan.model;

/*
 * BookMark.java - Short Description
 * Copyright (C) 1999-2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.io.Serializable;
import java.util.Calendar;
import org.wffm.gassan.model.translator.GTranslator;

/**
  * 
  * @version 1.1.2,2000/12/13
  * @author Yosuke Sato
  */
public class Bookmark implements Serializable{
	//
	//  ֘A
	//
	//=========================================================================
	private GTranslator _translator = null;

	//
	//  
	//
	//=========================================================================
	private String name = null;
	private Calendar calendar = null;
/**
  * RXgN^
  * @param	name		̖O
  * @param	calendar	ۑt
  * @param	gTranslator	GTranslator
  */
public Bookmark(String name,Calendar calendar,GTranslator _translator){
	this.name = name;
	this.calendar = calendar;
	this._translator = _translator;
}
/**
  * ۑt擾
  * @return	ۑt
  */
public Calendar getCalendar(){
	return calendar;
}
/**
  * GTranslator擾
  * @return	GTranslator
  */
public GTranslator getGTranslator(){
	return _translator;
}
/**
  * ̖O擾
  * @return	̖O
  */
public String getName(){
	return name;
}
}
