package org.wffm.gassan.view.effect;

/*
 * OverLay.java - Short Description
 * Copyright (C) 1999-2001 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.image.BufferedImage;
import java.awt.AlphaComposite;
import java.awt.Graphics2D;
import java.awt.Graphics;

/**
  * C[Wdˍ킹GtFNgNX
  * @version 1.1.0, 2001/01/06
  * @author Yosuke Sato
  */
public class OverLay extends ExchangeEffect {
/**
  * RXgN^
  */
public OverLay() {
}
/**
  * ʏ
  */
public void init(){
}
/**
  * ʏJn
  */
public void run(){
	//O:getImageSize(),getComponent(),getBeforeImage(),getAfterImage()nullłȂƁD
	if(getImageSize() != null && getComponent() != null && getBeforeImage() != null && getAfterImage() != null){
		//tB^[̉ 1
		int filter = 5;
	    float trans=1.0f;
	
		Graphics g = getComponent().getGraphics();
		for(int j = 0; j < filter ;j++){
			BufferedImage bimg = (BufferedImage)getComponent().createImage((int)getImageSize().getWidth(),(int)getImageSize().getHeight());
			Graphics2D g2 = bimg.createGraphics();
			g2.drawImage(getAfterImage(),0,0,getComponent());
			AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER,trans);
			g2.setComposite(ac);
			g2.drawImage(getBeforeImage(),0,0,getComponent());

			g.drawImage(bimg,0,0,getComponent());
			trans = trans - 0.2f;
		}
	}
	else{
		System.err.println("can not run : OverLay");
	}
}
}
