/* Public Domain Sources */

package org.wffm.gassan.view.filter;

import java.awt.Image;
import java.awt.Toolkit;

import java.awt.image.ImageProducer;
import java.awt.image.FilteredImageSource;

import org.wffm.gassan.view.image.ImageCreaterException;import java.util.List;/**
  * u[tB^[NX
  * @version 1.0.0, 2000/12/01
  * @author D.Miki
  * @author Yosuke Sato
  */
public class BlueFilter extends Filter {
public static Image filtering(Image i) {
	return Toolkit.getDefaultToolkit().createImage(
	  new FilteredImageSource(i.getSource(), new BlueFilter())
	);
}        
/**
 * RXgN^
 */
public BlueFilter() {
	super();
	canFilterIndexColorModel = true;
}          
public int filterRGB(int x, int y, int rgb) {
	int r = (int)( 0.7 * ((rgb >> 16) & 0xff) );
	if(r > 150)r = 150;
	int g = (int)( 0.7 * ((rgb >> 8) & 0xff) );
	if(g > 180)g = 180;
	int b = (int)(rgb & 0xff);
	return (rgb & 0xff000000) | (r << 16) | (g << 8) | (b << 0);
}        
/**
  * C[W擾
  * @return	C[W
  */
public Image getImage() throws ImageCreaterException{
	Image ret = null;

	try{
		Image sourceImage = getSource().getImage();
		ret = Toolkit.getDefaultToolkit().createImage( new FilteredImageSource(sourceImage.getSource(), this));
	}catch(Exception e){
		throw new ImageCreaterException();
	}
	return ret;
}}