/* Public Domain Sources */

package org.wffm.gassan.view.filter;

import java.awt.Image;
import java.awt.Toolkit;

import java.awt.image.ImageProducer;
import java.awt.image.FilteredImageSource;

import org.wffm.gassan.view.image.ImageCreaterException;import java.util.List;/**
  * RedWhitetB^[NX
  * @version 1.0.0, 2000/12/01
  * @author D.Miki
  * @author Yosuke Sato
  */
public class RedWhiteTransparentFilter extends Filter {
public static Image filtering(Image i) {
	return Toolkit.getDefaultToolkit().createImage(
	  new FilteredImageSource(i.getSource(),new RedWhiteTransparentFilter())
	);
}        
/**
 * RXgN^
 */
public RedWhiteTransparentFilter() {
	super();
	canFilterIndexColorModel = true;
}        
public int filterRGB(int x, int y, int rgb) {
	if (rgb == 0xffff0000 || rgb == 0xffffffff)return (rgb & 0xffffff);
	return rgb;
}        
/**
  * C[W擾
  * @return	C[W
  */
public Image getImage() throws ImageCreaterException{
	Image ret = null;

	try{
		Image sourceImage = getSource().getImage();
		ret = Toolkit.getDefaultToolkit().createImage( new FilteredImageSource(sourceImage.getSource(), this));
	}catch(Exception e){
		throw new ImageCreaterException();
	}
	return ret;
}}