package org.wffm.gsmlviewer;

/*
 * AppletAudioPlayer.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.net.URL;
import java.net.MalformedURLException;
import java.applet.Applet;
import java.applet.AudioClip;

/**
  * AppletytNX
  * @version 1.0.1, 2000/11/22
  * @author Yosuke Sato
  */
public class AppletAudioPlayer extends AudioPlayer{
	//
	//  [Jϐ
	//
	//=========================================================================
	private AudioClip audioClip = null;
/**
 * RXgN^
 */
public AppletAudioPlayer(){
}
/**
  * NA
  */
public void clear(){
	stop();
	setLoop(false);
	audioClip = null;
}
/**
  * tJn
  */
public void play(){
	if(getState()){
		if(audioClip != null){
			if(getLoop()){
				audioClip.loop();
			}
			else{
				audioClip.play();
			}
		}
	}
}
/**
  * yݒ
  * @param	source	\[XURL
  */
public void setAudio(URL source){
	setSource(source);
	
	stop();
	audioClip = null;
	
	if(source != null){
		audioClip = Applet.newAudioClip(source);
	}
}
/**
  * t~
  */
public void stop(){
	if(audioClip != null){
		audioClip.stop();
	}
}
}
