package org.wffm.gsmlviewer;

/*
 * GEMLUtility.java - Short Description
 * Copyright (C) 2000 WFFM
 * koutei@erl.ee.musashi-tech.ac.jp
 * http://www.wffm.org/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.awt.Dimension;
import java.util.Hashtable;

import org.wffm.gassan.model.scenario.GElement;
import org.wffm.gassan.model.scenario.GElementList;

/**
  * GEMLpc[NX
  * @version 1.0.1, 2000/11/22
  * @author Yosuke Sato
  */
public class GEMLUtility {
/**
  * GEML/GSMLGg(plugin)p[^
  * @param	element	GEML/GSML
  * @return	p[^
  */
public static Hashtable getParam(GElement element){
	Hashtable ret = new Hashtable();
	
	GElementList list = element.getChildElements();
	GElement param;

	for( list.first(),param = list.item() ; param != null ; list.next(),param = list.item() ){
		if( param.getName().equals("param") ){
			String name = param.getAttributeValue("name");
			String value = param.getAttributeValue("value");
			ret.put(name,value);
		}
	}
			
	return ret;
}
}
